︠4b4e26e3-b7dc-468a-9862-91d05d362bcei︠
%md
###Bug in Sage Integral Computations?###
︡566a5380-611a-4fdd-8894-677724bab8e3︡{"md":"###Bug in Sage Integral Computations?###"}︡
︠241b4f26-f144-44fc-9fa4-215b556016f2︠
# Better version of FriCAS mode for SageMathCloud
os.environ['PATH'] = '%s/bin:%s'%(os.environ['HOME'],os.environ['PATH'])
from fricas import fricas
execfile('fricas_md.py')
%default_mode fricas_md
︡a2a0234d-edf0-45a8-b89c-58b455384cc6︡
︠a29ca70a-20bd-4963-a06d-7a575d8f2daf︠
)version
)clear completely
)set output tex on
)set output algebra off
︡42b3bfb2-d8b7-4b27-a184-9eb554ff5213︡{"md":"\n\nValue = \"FriCAS 2014-12-18 compiled at Tue May  5 18:13:01 UTC 2015\"\n\n   All user variables and function definitions have been cleared.\n\n   All )browse facility databases have been cleared.\n\n   Internally cached functions and constructors have been cleared.\n\n   )clear completely is finished.\n\n"}︡
︠ecff00c0-9e59-41dc-902d-3e110356d59e︠
︡a2e7f636-5873-41a9-977b-f0c6acce0e3f︡{"md":"FriCAS agrees with Sage that the value of the integral is 0."}︡
︠16dc582e-3a71-422c-b7e1-455707c73e5b︠
ex:=sqrt( cot(x)^2 )
︡aa7606bf-23ba-4410-be1a-521ae761e7f3︡{"md":"\n\n$$\n\n\\sqrt {{{{\\cot \n\n\\left(\n\n{x} \n\n\\right)}}\n\n^{2}}} \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>\n"}︡
︠c2323e91-93ed-4cb8-8b98-c1578db4357a︠
i1:=integrate(ex, x = %pi/4 .. 3*%pi/4,"noPole")
︡21954a73-2f4c-4ddc-8ce3-8d98f839f389︡{"md":"\n\n$$\n\n0 \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Union(f1: OrderedCompletion(Expression(Integer)),...)</p>\n"}︡
︠4dfe974e-5c74-4f21-be1b-f7b780ed5c68︠
%sage
typeset_mode(true)
s1=integrate(sqrt( cot(x)^2 ), x,pi/4,3*pi/4);s1
︡a0d8bfb9-3ab1-49e9-8c37-73ffca61e574︡{"tex":{"tex":"0","display":true}}︡
︠8bf97b81-879f-4bc1-ae2e-b1a55e47ce76i︠
%md Consider the indefinite integral
︡596c926c-6df4-43dd-92bf-36464d86f0da︡{"md":"Consider the indefinite integral"}︡
︠df0f6500-6f57-4a6c-a8f7-dc6916e657e4︠
i2:=integrate(ex, x)
︡606a20c2-d04a-41a8-93da-ce9af04fb590︡{"md":"\n\n$$\n\n{{2 \\  {\\log \n\n\\left(\n\n{{{\\sin \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}\n\n\\over {{\\cos \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}+1}}}\n\n\\right)}}\n\n-{\\log \n\n\\left(\n\n{{2 \\over {{\\cos \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}+1}}}\n\n\\right)}}\n\n\\over 2 \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Union(Expression(Integer),...)</p>\n"}︡
︠ddee2580-df6c-403c-9365-6db9477aff5f︠
%sage s2=fricas('i2::Expression Integer').sage();s2
︡4b8e3098-0001-4ca0-87b7-eae051387e72︡{"tex":{"tex":"\\log\\left(\\frac{\\sin\\left(2 \\, x\\right)}{\\cos\\left(2 \\, x\\right) + 1}\\right) - \\frac{1}{2} \\, \\log\\left(\\frac{2}{\\cos\\left(2 \\, x\\right) + 1}\\right)","display":true}}︡
︠6cb92976-6141-4ddd-acd5-192899519499︠
%sage plot(s2,x,pi/4,2*pi/4)
︡1a97c147-b308-4421-a482-7e982669be45︡{"once":false,"file":{"show":true,"uuid":"c2be116c-e182-46f5-a1a0-1dddbd35dd4d","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/29292/tmp_F93eh4.svg"}}︡{"html":"<div align='center'></div>"}︡
︠cfeec6bc-f345-48d8-86f5-bd49ec68fe1ci︠
%md There is a pole at $\pi/2$ and the branch becomes complex after that point.
︡6f6f1242-23c6-4d77-8be2-981d811e3437︡{"md":"There is a pole at $\\pi/2$ and the branch becomes complex after that point."}︡
︠ed78e64b-aac2-48d0-acb5-791ca52ab926︠
eval(i2,x=2*%pi/4-0.0001)
︡60e2e438-9ecc-4392-9d1d-17884e105967︡{"md":"\n\n$$\n\n-{0.4999955155 E -8} \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Expression(Float)</p>\n"}︡
︠ad29c5c1-337f-45e0-af1b-3668ebc3b41d︠
eval(i2,x=3*%pi/4)
︡0aa95b2a-bf88-460d-9292-0f35ab24c47c︡{"md":"\n\n$$\n\n{-{\\log \n\n\\left(\n\n{2} \n\n\\right)}+{2\n\n\\  {\\log \n\n\\left(\n\n{-1} \n\n\\right)}}}\n\n\\over 2 \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>\n"}︡
︠49a20c83-0726-492a-9c7d-7dac5435eee3︠
complexNumeric %
︡c06f3d5e-689f-47c0-a4ef-a08cc01be801︡{"md":"\n\n$$\n\n-{0.3465735902\\_7997265471}+{{3.1415926535\\_897932385} \\  i} \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Complex(Float)</p>\n"}︡
︠7d88a933-21d6-4fa5-8eba-f38226ae5a64i︠
%md Both $\sqrt \ $ and $\log(x)$ for $x<0$ are "multi-valued functions".  In the case of log, the branches for negative numbers differ by $i\pi$, so we can choose a branch that is real-valued.
︡258526c1-7441-4064-be01-60acb822e1c7︡{"md":"Both $\\sqrt \\ $ and $\\log(x)$ for $x<0$ are \"multi-valued functions\".  In the case of log, the branches for negative numbers differ by $i\\pi$, so we can choose a branch that is real-valued."}︡
︠d14fda00-b130-4387-84c2-97e31bf02ffe︠
i3:=i2-%pi*%i
︡7fc2d42e-2c09-4edb-9476-12b3c4090325︡{"md":"\n\n$$\n\n{{2 \\  {\\log \n\n\\left(\n\n{{{\\sin \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}\n\n\\over {{\\cos \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}+1}}}\n\n\\right)}}\n\n-{\\log \n\n\\left(\n\n{{2 \\over {{\\cos \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}+1}}}\n\n\\right)}\n\n-{2 \\  i \\  \\pi}} \\over 2 \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Expression(Complex(Integer))</p>\n"}︡
︠58ce1eaf-b151-493a-9377-db368b76dec4︠
eval(i3,x=3*%pi/4)
︡85d664b9-5b63-4e6e-a1d5-b7b06cb0c2ab︡{"md":"\n\n$$\n\n{-{\\log \n\n\\left(\n\n{2} \n\n\\right)}+{2\n\n\\  {\\log \n\n\\left(\n\n{-1} \n\n\\right)}}\n\n-{2 \\  i \\  \\pi}} \\over 2 \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Expression(Complex(Integer))</p>\n"}︡
︠27cfee87-98c3-4d42-b8f4-1b20ed72b7a3︠
complexNumeric %
︡9b002646-34fe-4dfb-be1d-61e541ccf72f︡{"md":"\n\n$$\n\n-{0.3465735902\\_7997265471} \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Complex(Float)</p>\n"}︡
︠d9614d1a-cadd-448b-b846-71cc42893dc9︠
%sage s3=fricas('i2::Expression Integer').sage()-pi*i;s3
︡130d31c7-63f7-4cb0-8813-cf4a8d8c5794︡{"tex":{"tex":"-i \\, \\pi + \\log\\left(\\frac{\\sin\\left(2 \\, x\\right)}{\\cos\\left(2 \\, x\\right) + 1}\\right) - \\frac{1}{2} \\, \\log\\left(\\frac{2}{\\cos\\left(2 \\, x\\right) + 1}\\right)","display":true}}︡
︠c3ee0be6-58a6-4e59-bfd9-679f90667a1f︠
%sage s3.substitute(x=3*pi/4)
︡91d21721-06a3-4d3b-b867-d39ec899daec︡{"tex":{"tex":"-\\frac{1}{2} \\, \\log\\left(2\\right)","display":true}}︡
︠6e44b338-a383-4a80-831b-d88c8e64283c︠
%sage
def ss(x0):
  return s3.substitute(x=x0).N()
︡b7b671c0-0ee6-47da-b9e1-f00654f3bc8b︡
︠cb069820-1cc3-48bf-b09c-5e37cafbf439︠
%sage ss(2*pi/4+0.0001)
︡f2410e7e-07d3-4559-a026-2d59f78b8a67︡{"stdout":"-3.62865471004170e-9\n"}︡
︠bafe6c41-1f0b-4465-b56d-3ea75fe04f09︠
%sage plot(ss,2*pi/4+0.0001,3*pi/4)
︡bb194e8d-14db-4f1e-b1d7-63bbcd7b4d1a︡{"once":false,"file":{"show":true,"uuid":"4d0fb17f-8b6d-4ce3-82f2-7861aeb43d4a","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/29292/tmp_EELFrp.svg"}}︡{"html":"<div align='center'></div>"}︡
︠648ec03c-a3d6-4665-b066-53c19c1878d5i︠
%md We expect the derivative of the indefinite integral to be equal to the original expression.
︡ed5602b4-605a-42c2-840e-979a0fcb5175︡{"md":"We expect the derivative of the indefinite integral to be equal to the original expression."}︡
︠9f47f562-dad6-4b43-869d-ee77c2a1c33a︠
d1:=differentiate(i2,x)
︡e825ad7a-612e-473c-8342-3d96669f38e0︡{"md":"\n\n$$\n\n{{{{\\sin \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}}\n\n^{2}}+{2 \\  {{{\\cos \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}}\n\n^{2}}}+{2 \\  {\\cos \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}}}\n\n\\over {{\\left( {\\cos \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}+1\n\n\\right)}\n\n\\  {\\sin \n\n\\left(\n\n{{2 \\  x}} \n\n\\right)}}\n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>\n"}︡
︠8518f65c-5270-488d-967a-9cfc03769eb4i︠
%md
In FriCAS ```normalize``` rewites an expression "using the least possible number of algebraically independent kernels".
︡76478793-bccf-4218-a7c9-b37c6b4730dd︡{"md":"In FriCAS ```normalize``` rewites an expression \"using the least possible number of algebraically independent kernels\".\n"}︡
︠6eb20b74-b77e-44d9-858d-8c61167650d6︠
normalize(ex-d1)
︡65e0592a-cf50-43a0-b2eb-efa275772fe9︡{"md":"\n\n$$\n\n0 \n\n\n$$\n\n\n\n<p style=\"text-align:right\">Type: Expression(Integer)</p>\n"}︡
︠3daca25c-54c9-48a7-be16-bb407d29c0f5︠
%sage s2=integrate( sqrt( cot(x)^2 ), x); s2
︡27d7022b-9701-4572-bb6c-09b21374f415︡{"tex":{"tex":"-\\frac{1}{2} \\, \\log\\left(\\tan\\left(x\\right)^{2} + 1\\right) + \\log\\left(\\tan\\left(x\\right)\\right)","display":true}}︡
︠8a9552e4-8ec1-4def-82f0-e4dfb204a4a6︠
%sage (fricas(s2)-fricas('i2')).normalize().sage()
︡01c38f2d-15ff-418e-a7d6-fa1df1c73968︡{"tex":{"tex":"0","display":true}}︡
︠0a2694bf-93d3-4dc7-a8ec-275d9e8ef89fi︠
%md
The conclusion is that although these results are not identical they are nonetheless algebraically dependent.
︡16e09bcf-1b51-4b04-9829-83b2954a38d3︡{"md":"The conclusion is that although these results are not identical they are nonetheless algebraically dependent."}︡
︠5b9dbecb-5219-4032-b92e-545bff68f821︠
︡fd9f0d79-7237-4c39-a8f4-a01c66ed9fe9︡
︠3b399fa1-a6b4-4ed2-8d9c-6384cb10eb48︠









